// GOAL of the CODE
//1) LEDS light up as soon as simulation starts showing the board has power!
//2) Microphone Starts taking measurements
//3) IF the difference measured mic values and threshold value meets the standard for sound detection then 
 //motor spins & servo rotates back and forth 
// (Meets standard if measured mic values are different from threshold by +/- 4 Hz to indicate baby crying)
//4)If button is held down while motor is spinning, motor temporarily stops moving 
// Motor stopis only temporary until the if statemnt is re-entered within the void loop
//5) IF Measured Microphone Values Does NOT meet the above criteria for triggering, only output is LED light 

#include <Servo.h> 
Servo myservo;
int angle;
int dt = 10;
int sensorValue = 0;// microphone sensor value 
int diff1 = 0; //for sound filtering
int threshold = 334;  // sound level threshold 
int standard = 4; 

void setup() {
  // put your setup code here, to run once:
   Serial.begin(9600);
   pinMode(13, OUTPUT);//motor set to output
   pinMode(12, OUTPUT); //motor set to ouput
   pinMode(5, INPUT); //button set to input 
   myservo.attach(6); ////Servo set to Output 
}

void loop() {
  // put your main code here, to run repeatedly:
    sensorValue = analogRead(A0);
    diff1 = abs(sensorValue- threshold); 
    Serial.println(diff1);
  //will not trigger the motor and sensor inputs if there is not an appropriate sound
  if(diff1 > standard){ // enter if sensor value is producing value in appropriate range
     // motor spins 
     analogWrite(12,128); // get motor spining in opposite direction 
     digitalWrite(13, LOW);
     //servo spins 
     while(angle<180){  // rotate forward in 1 degree increments
      angle++;        // increment angle
      myservo.write(angle); // move to new angle
      delay(dt);  
      }//while 1 end
     while(angle>0){ // rotate backward in 1 degree increments
     angle--;        // decrement angle
     myservo.write(angle); //move to new angle
     delay(dt);
      }//while 2 end 
    //button press can be detected 
   
    if(digitalRead(5) == HIGH){ //if button is pressed then motor stops spinning 
     //motor stops spinning at values between 0 and 120 
     analogWrite(12,100); // get motor to momentarily stop spinning 
     digitalWrite(13, LOW);
     delay(2000); // delay so viewer can visably see the motor stop moving 
    }// button push end 
    
  }//overall sound detection if statement
}
